/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
 
var pictureSource;   // picture source
var destinationType; // sets the format of returned value 	

document.addEventListener('deviceready', function () {
  // Enable to debug issues.
  // window.plugins.OneSignal.setLogLevel({logLevel: 4, visualLevel: 4});
  
  var notificationOpenedCallback = function(jsonData) {
    //alert('notificationOpenedCallback: ' + JSON.stringify(jsonData));
	var title='';
	var mess='';
	$(jsonData).each(function(i,val){
		$.each(val,function(k,v){
			$.each(v,function(w,x){
				if(w == 'payload'){
					$.each(x,function(y,z){
						if(y == 'title') { title = z; }
						if(y == 'body') { mess = z; }
					});
				}
			});
		});
	});
	
	if(title!='' && mess !='' && localStorage.getItem('registrationId')!=''){
		$.post( "http://phonegap.cwadevelopment.co.uk/postmessage.php", { 
			r: localStorage.getItem('registrationId'), 
			m: mess, 
			t: title 
		})
		.done(function( data ) {
			//alert(data);		
		});
	}
	
  };

  window.plugins.OneSignal
    .startInit("58ecc1cf-ec07-47a1-a71d-e6a9db72cf01", "698120650177")
    .handleNotificationOpened(notificationOpenedCallback)
    .endInit();
  
  // Sync hashed email if you have a login system or collect it.
  //   Will be used to reach the user at the most optimal time of day.
  // window.plugins.OneSignal.syncHashedEmail(userEmail);
}, false);

//alert('start');
 
var app = {
    // Application Constructor
    initialize: function() {
        app.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', app.onDeviceReady, false);
		//alert('deviceready');
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        //alert('Received Device Ready Event');
        //console.log('calling setup push');
        app.setupPush();
		app.setFooter();
		app.getNotifications();
		app.getTimeline();
		app.getLoggegtime();
		app.getMyteam();
		app.getCamera();
		app.getAwards();
		app.displayAwards();
    },
    setupPush: function() {
        //alert('calling push init');
        var push = PushNotification.init({
            "android": {
                "senderID": "12345679"
            },
            "browser": {},
            "ios": {
                "sound": true,
                "vibration": true,
                "badge": true
            },
            "windows": {}
        });
        //alert('after init');
		

        push.on('registration', function(data) {
            //alert('registration event: ' + data.registrationId);
			
			$("#regid").val(data.registrationId);
			
			$.post( "http://phonegap.cwadevelopment.co.uk/checkactive.php", { regid: $("#regid").val() })
			.done(function( data ) {
				var json = $.parseJSON(data);
				$(json).each(function(i,val){
					$.each(val,function(k,v){
						if(v==1) { window.location.href='dashboard.html'; }  //auto move to dashboard as active
					});
				});
			});
			
			

            var oldRegId = localStorage.getItem('registrationId');
            if (oldRegId !== data.registrationId) {
                // Save new registration ID
                localStorage.setItem('registrationId', data.registrationId);
                // Post registrationId to your app server as the value has changed
            }
			
			//alert('regID: '+localStorage.getItem('registrationId'));

            var parentElement = document.getElementById('registration');
            var listeningElement = parentElement.querySelector('.waiting');
            var receivedElement = parentElement.querySelector('.received');

            listeningElement.setAttribute('style', 'display:none;');
            receivedElement.setAttribute('style', 'display:block;');
        });
		

        push.on('error', function(e) {
            //alert("push error = " + e.message);
        });

        push.on('notification', function(data) {
			
            //console.log('notification event');
			$.post( "http://phonegap.cwadevelopment.co.uk/postmessage.php", { regid: localStorage.getItem('registrationId'), mess: data.message })
			.done(function( data ) {
				//console.log(data);
				//console.log('message posted');		
			});
            navigator.notification.alert(
                data.message,         // message
                null,                 // callback
                data.title,           // title
                'Ok'                  // buttonName
            );
       });
    },
	setFooter: function(){
		//console.log(window.location.pathname);
	
	},
	getNotifications: function() {
		var r = localStorage.getItem('registrationId');
		if($(".notifications").length){
			$.post( "http://phonegap.cwadevelopment.co.uk/getmessages.php", { regid: r })
			.done(function( data ) {
				var replaceHTML = data;
				$(".notifications .row").html(replaceHTML);
			});
		}	
	},
	getTimeline: function() {
		var r = localStorage.getItem('registrationId');
		if($(".timeline").length){
			$.post( "http://phonegap.cwadevelopment.co.uk/getTimeline.php")
			.done(function( data ) {
				var replaceHTML = data;
				$(".timeline .row").html(replaceHTML);
			});
		}	
	},
	getLoggegtime: function() {
		var r = localStorage.getItem('registrationId');
		if($(".logtime").length){
			$.post( "http://phonegap.cwadevelopment.co.uk/getLoggedTime.php", { regid: r })
			.done(function( data ) {
				var replaceHTML = data;
				$(".logtime .displaytable").html(replaceHTML);
			});
		}	
	},
	getMyteam: function() {
		var r = localStorage.getItem('registrationId');
		if($(".myteam").length){
			
			$.post( "http://phonegap.cwadevelopment.co.uk/getMyteam.php", { regid: r })
			.done(function( data ) {
				if(data == 'forcelogin'){
					window.location.href='index.html'; // registration id has changed so force a login
				}else{	
					var replaceHTML = data;
					$(".myteam .row").html(replaceHTML);
				}
			});
		}	
	},
	getCamera: function() {
		pictureSource=navigator.camera.PictureSourceType;
        destinationType=navigator.camera.DestinationType;
	},
	getAwards: function() {
		var r = localStorage.getItem('registrationId');
		$.post( "http://phonegap.cwadevelopment.co.uk/getAwards.php", { regid: r })
		.done(function( data ) {
			var json = $.parseJSON(data);
			$(json).each(function(i,val){
				$.each(val,function(k,v){
					//if(k=='title') $("#myawards .modal-body h4").html(v);
					if(k=='word') $("#myawards .modal-body p").html(v);
					if(k=='colour') $("#myawards").addClass(v);
					if(k=='image') $("#myawards .modal-body img").attr("src", v);
				});
			});
			$("#myawards").modal('show'); // show model box
		});
	},
	displayAwards: function() {
		var r = localStorage.getItem('registrationId');
		if($(".myawards").length){
			$.post( "http://phonegap.cwadevelopment.co.uk/displayAwards.php", { regid: r })
			.done(function( data ) {
				$(".rowcontainer").html(data);
			});
		}
	}
	
};



